var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
function createContext(ctx = {}) {
  window[Symbol.for("___VML_CONTEXT___")] = ctx;
  return window[Symbol.for("___VML_CONTEXT___")];
}
function install(app, ctx) {
  var _a;
  if (!((_a = app.version) == null ? void 0 : _a.startsWith("3"))) {
    throw new Error(`[vue-module-loader]: \u4EC5\u9002\u7528\u4E8Evue3`);
  } else {
    createContext(__spreadValues({
      app
    }, ctx));
  }
}
const moduleUninstallerMap = {};
function uninstallCache(moduleName, uninstaller) {
  moduleUninstallerMap[moduleName] = uninstaller;
}
function list() {
  return moduleUninstallerMap;
}
function uninstall(moduleName) {
  return __async(this, null, function* () {
    moduleUninstallerMap[moduleName](window[Symbol.for("___VML_CONTEXT___")]);
  });
}
function clear() {
  return __async(this, null, function* () {
    for (let moduleName in moduleUninstallerMap) {
      moduleUninstallerMap[moduleName](window[Symbol.for("___VML_CONTEXT___")]);
    }
  });
}
function loadStyle(moduleData, moduleHostUrl) {
  return new Promise((resolve, reject) => {
    const style = document.createElement("link");
    style.id = moduleData.name;
    style.rel = "stylesheet";
    style.crossOrigin = "anonymous";
    style.href = moduleHostUrl + "style.css";
    style.onload = () => {
      resolve();
    };
    style.onerror = () => {
      resolve();
    };
    document.head.append(style);
  });
}
function bootModule(moduleData, moduleHostUrl) {
  return __async(this, null, function* () {
    const context = window[Symbol.for("___VML_CONTEXT___")];
    let installReturn;
    try {
      console.log(`[vue-module-loader]: \u6A21\u5757\u300C${moduleData.name}\u300D\u5F00\u59CB\u52A0\u8F7D...`);
      if (moduleHostUrl) {
        yield loadStyle(moduleData, moduleHostUrl);
      }
      installReturn = yield moduleData.install(context);
      console.log(`[vue-module-loader]: \u6A21\u5757\u300C${moduleData.name}\u300D\u52A0\u8F7D\u5B8C\u6210\u3002`);
      uninstallCache(moduleData.name, moduleData.uninstall);
    } catch (error) {
      console.error(
        `[vue-module-loader]: \u6A21\u5757\u300C${moduleData.name}\u300D\u52A0\u8F7D\u9519\u8BEF\uFF01`,
        error
      );
      installReturn = error;
    }
    return installReturn;
  });
}
function useModule(moduleData, ctx) {
  return __async(this, null, function* () {
    const existingContext = window[Symbol.for("___VML_CONTEXT___")] || createContext(ctx);
    let bootResult;
    if (typeof moduleData === "object") {
      bootResult = yield bootModule(moduleData);
    } else if (typeof moduleData === "string") {
      if (!existingContext.Vue)
        throw new Error("[vue-module-loader]: \u4E0A\u4E0B\u6587\u5BF9\u8C61\u7F3A\u5C11Vue\u5BF9\u8C61");
      const res = yield fetch(moduleData);
      const moduleString = yield res.text();
      const moduleCode = moduleString.replace(
        /^(var|const).+function/,
        "return function"
      );
      const moduleStringFun = Function(`return function(vue){${moduleCode}}`)();
      const moduleDataFromUrl = moduleStringFun(existingContext.Vue);
      bootResult = yield bootModule(
        moduleDataFromUrl,
        moduleData.match(/\S*\//)[0]
      );
    }
    return bootResult;
  });
}
function useContext(key, instance) {
  if (!window[Symbol.for("___VML_CONTEXT___")]) {
    createContext();
  }
  if (instance) {
    window[Symbol.for("___VML_CONTEXT___")][key] = instance;
  }
  if (!key) {
    return window[Symbol.for("___VML_CONTEXT___")];
  } else {
    if (window[Symbol.for("___VML_CONTEXT___")][key] === void 0) {
      window[Symbol.for("___VML_CONTEXT___")][key] = null;
      console.warn(
        `[vue-module-loader]\uFF1A\u4E0A\u4E0B\u6587\u4E2D\u4E0D\u5B58\u5728\u201C${key}\u201D\uFF0C\u65E2\u7136\u4F60\u8981\u7528\uFF0C\u6211\u5148\u5E2E\u4F60\u5360\u4E2A\u5751\uFF08\u521D\u59CB\u5316\u4E3Anull\uFF09\u3002`
      );
    }
    return window[Symbol.for("___VML_CONTEXT___")][key];
  }
}
export {
  clear,
  install as default,
  list,
  uninstall,
  useContext,
  useModule
};
//# sourceMappingURL=vue-module-loader.js.map
